#include "gsmhacking.h"

/* get the last entry in a list, ie the first entry with this->next = 0 */
struct gll *gll_last(struct gll *first) {
  struct gll *tmp;
  GLL_CLOSED_LOOP(tmp, first) TRACE1("first: %p, tmp: %p\n", first, tmp); return tmp;
}

struct gll *gll_alloc() {
#if 0
  return (struct gll *) alloc_one("gll", sizeof(struct gll));
#endif
  struct gll *ret = (struct gll *) alloc_one("gll", sizeof(struct gll));
  if (! ret) return 0;
  ret->next = 0;
  return ret;
}

/* add a new entry in a list and return head! */
struct gll *gll_add(struct gll **old) {
  struct gll *ret, *tmp;
  ret = gll_alloc();
  if (! ret) return 0;
  if (*old) {
    tmp = gll_last(*old);
    tmp->next = ret;
    return *old;
  }
  return ret;
}

/* add the start of one list to the end of another */
void gll_append(struct gll **dest, struct gll *src) {
  struct gll *tmp = gll_last(*dest);
  TRACE1("dest: %p and tmp: %p with src: %p\n", *dest, tmp, src);
  if (tmp) tmp->next = src;
  else *dest = src;
}

/* set the value of the last one */
void gll_set_last(struct gll *first, unsigned short value) {
  struct gll *tmp = gll_last(first);
  if (! tmp) {
    ERROR("called with null struct gll star\n");
    return;
  }
  tmp->n = value;
}

void gll_debug(struct gll *first) {
  struct gll *tmp;
  GLL_LOOP(tmp, first) DEBUG("%p -> %p\n", tmp, tmp->next);
}

void gll_trace1(struct gll *first) {
  struct gll *tmp;
  GLL_LOOP(tmp, first) TRACE1("%p -> %p\n", tmp, tmp->next);
}

void gll_free(struct gll *one) {
  struct gll *two;
  if (! one) return;
  do {
    two = one->next;
    free(one);
  } while (two->next);
  if (two) free(two);
}
