#ifndef MAP_H
#define MAP_H
#include "data.h"

struct map_set {
  struct map_set *next;
  char *material;
  char *type;
  int texture_id;
};

GSM_API struct map **alloc_maps(unsigned short);
GSM_API struct map *alloc_map();
GSM_API void cleanup_maps(unsigned short, struct map **);
GSM_API int find_maps(struct gsm *, struct material *);
GSM_API int parse_map(struct gsm *, unsigned short, struct map *, unsigned short);
GSM_API char *get_map_type_name(unsigned short);
GSM_API char *get_all_map_type_names(struct material *, int *);
GSM_API int write_maps(struct gsm *, unsigned short);
GSM_API int get_map_type_by_name(char *);
GSM_API unsigned short get_num_maps(struct gsm *, unsigned short);
GSM_API struct map_set *alloc_map_set();
GSM_API int add_to_map_set(struct map_set **, char *, char *, char *);
GSM_API int list_map_types();

/* damn gonna have to do this properly */
#ifndef __cplusplus
static unsigned char *map_type_name[12] = {
  "ambient", "diffuse", "specular", "shininess", "shine-strength"
 ,"self-illumination" ,"opacity", "filter-colour", "bump-map"
 ,"reflection", "refraction" ,"displacement"
};
#endif

#define NUM_MAP_TYPES 12
#define MAP_TYPE_AMBIENT 0 /* unconfirmed */
#define MAP_TYPE_DIFFUSE 1
#define MAP_TYPE_SPECULAR 2 /* unconfirmed */
#define MAP_TYPE_SHININESS 3
#define MAP_TYPE_SHINE_STRENGTH 4 /* unconfirmed */
#define MAP_TYPE_SELF_ILLUMINATION 5 /* unconfirmed */
#define MAP_TYPE_TRANSPARENCY 6
#define MAP_TYPE_FILTER_COLOUR 7 /* unconfirmed */
#define MAP_TYPE_BUMP 8 /* unconfirmed */
#define MAP_TYPE_REFLECTION 9
#define MAP_TYPE_REFRACTION 10
#define MAP_TYPE_DISPLACEMENT 11 /* unconfirmed */

struct map {
  unsigned short map_type;
  unsigned short texture_id;
};

#endif
