#ifndef MAPPING_H
#define MAPPING_H

#define SORT_MAPPING_DEFAULT 0
#define SORT_MAPPING_NORMALISED 1

/* a mapping is just a hash but without any optimsation */
typedef struct {
  unsigned short key;
  unsigned short value;
} mapping_value_t;

typedef struct {
  unsigned short size;
  mapping_value_t **pairs;
} mapping_t;

GSM_API mapping_value_t **alloc_mapping_values(unsigned short);
GSM_API mapping_value_t *alloc_mapping_value();
GSM_API mapping_t *alloc_mapping(unsigned short);
GSM_API void initialise_mapping();
GSM_API void cleanup_mapping(mapping_t *);
GSM_API void pop_mapping(mapping_t *, unsigned short);
GSM_API int get_key_for_mapping(mapping_t *, unsigned short);
GSM_API int get_value_for_mapping(mapping_t *, unsigned short);
GSM_API int set_value_for_mapping(mapping_t *, unsigned short, unsigned short);
GSM_API int set_key_for_mapping(mapping_t *, unsigned short, unsigned short);
GSM_API int set_key_and_value_for_mapping(mapping_t *, unsigned short, unsigned short, unsigned short);
GSM_API int get_key_in_mapping(mapping_t *, unsigned short);
GSM_API int get_value_in_mapping(mapping_t *, unsigned short);
GSM_API int sort_mapping_by_value(mapping_t *, int);
GSM_API int sort_mapping_by_value_function(const void *, const void *);
GSM_API void debug_mapping(mapping_t *, char *);

#endif
