#ifndef SHARED_TRIANGLE_LIST_H
#define SHARED_TRIANGLE_LIST_H
#include "data.h"
#include <stdlib.h>

GSM_API struct shared_triangle_list **alloc_shared_triangle_lists(unsigned short);
GSM_API struct shared_triangle_list **alloc_more_shared_triangle_lists(unsigned short, unsigned short, struct shared_triangle_list **);
GSM_API struct shared_triangle_list *alloc_shared_triangle_list();
GSM_API unsigned short *alloc_shared_triangle();
GSM_API void cleanup_shared_triangle_lists(unsigned short, struct shared_triangle_list **);
GSM_API int find_shared_triangle_lists(struct gsm *);
GSM_API int parse_shared_triangle_list(struct gsm *, unsigned short, struct shared_triangle_list *, unsigned short, unsigned int *);
GSM_API int write_shared_triangle_lists(struct gsm *);
GSM_API char *get_shared_triangle_list(struct shared_triangle_list *);
GSM_API char *get_shared_triangle_list_as_positions(struct gsm *, unsigned short);
GSM_API int get_shared_triangle_list_shared_positions(struct gsm *, unsigned short, int **);
GSM_API int position_in_triangles(struct gsm *, struct shared_triangle_list *, unsigned short, int **, int *);
GSM_API int make_shared_triangle_list(struct gsm *);
GSM_API int describe_shared_triangle_lists(struct gsm *);

struct shared_triangle_list {
  unsigned int offset;
  unsigned short num_triangles;
  unsigned short **triangles;
};

#endif
