#ifndef TRIANGLE_H
#define TRIANGLE_H
#include "data.h"
#include <stdlib.h>

#define TRIANGLE_UNKNOWN 8

GSM_API struct triangle **alloc_triangles(unsigned short);
GSM_API struct triangle **alloc_more_triangles(unsigned short, unsigned short, struct triangle **);
GSM_API struct triangle *alloc_triangle();
GSM_API void cleanup_triangles(unsigned short, struct triangle **);
GSM_API int find_triangles(struct gsm *);
GSM_API int parse_triangle(struct gsm *, unsigned short, struct triangle *, unsigned short);
GSM_API int write_triangles(struct gsm *);
GSM_API char *get_triangle_as_positions(struct gsm *, unsigned short);
GSM_API int get_triangle_vertex_by_id(struct gsm *, unsigned short, unsigned short);
GSM_API int get_triangle_vertex_by_position(struct gsm *, unsigned short, unsigned short);
GSM_API int describe_triangles(struct gsm *);

struct triangle {
  unsigned int offset;
  unsigned short vertex1;
  unsigned short vertex2;
  unsigned short vertex3;
  unsigned short unknown; /* probably padding */
};

#endif
