#ifndef TRIANGLE_GROUP_H
#define TRIANGLE_GROUP_H
#include "data.h"
#include <stdlib.h>

GSM_API struct triangle_group **alloc_triangle_groups(unsigned short);
GSM_API struct triangle_group **alloc_more_triangle_groups(unsigned short, unsigned short, struct triangle_group **);
GSM_API struct triangle_group *alloc_triangle_group();
GSM_API void cleanup_triangle_groups(unsigned short, struct triangle_group **);
GSM_API int find_triangle_groups(struct gsm *);
GSM_API int parse_triangle_group(struct gsm *, unsigned short, struct triangle_group *, unsigned short);
GSM_API int write_triangle_groups(struct gsm *);
GSM_API int get_num_triangle_groups(struct gsm *, unsigned short);
GSM_API void zero_vertex_count/*_for_triangle_group*/(struct gsm * /*, unsigned short*/);
GSM_API int get_vertices_by_material(struct gsm *, unsigned short);
GSM_API int get_triangles_by_material(struct gsm *, unsigned short);
GSM_API int describe_triangle_groups(struct gsm *);
GSM_API int get_triangle_group_by_triangle(struct gsm *, unsigned short);

struct triangle_group {
  unsigned int offset;
  unsigned short material_id;
  unsigned short first_triangle;
  unsigned short num_triangles;
  unsigned short unknown; /* probably padding */
};

#endif
