#ifndef VERTEX_H
#define VERTEX_H
#include "data.h"
#include <stdlib.h>

GSM_API struct vertex **alloc_vertices(unsigned short);
GSM_API struct vertex **alloc_more_vertices(unsigned short, unsigned short, struct vertex **);
GSM_API struct vertex *alloc_vertex();
GSM_API void cleanup_vertices(unsigned short, struct vertex **);
GSM_API int find_vertices(struct gsm *);
GSM_API int parse_vertex(struct gsm *, unsigned short, struct vertex *, unsigned short);
GSM_API int write_vertices(struct gsm *);
GSM_API int get_position_by_vertex(struct gsm *, unsigned short);
GSM_API int get_texture_coord_by_vertex(struct gsm *, unsigned short);
GSM_API int get_vertex_by_count(struct gsm *, int);
GSM_API int set_position_for_vertices(struct gsm *, unsigned short, unsigned short);
GSM_API int describe_vertices(struct gsm *);

struct vertex {
  unsigned int offset;
  unsigned short texture_coord_id;
  unsigned short position_id;
  unsigned short shared_triangle_list_id;
  unsigned short hit_detect;
  int count; /* used by milkshape exporter */
  unsigned short num_triangles; /* how many triangles does this vertex feature in? */
};

char *hit_detect_location(unsigned short);
int import_hit_detect(struct gsm *);
#endif
